/*********************************************************************************
**
**   $Id: custvehcedit.ui.h,v 1.4 2004/05/27 11:44:07 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qmessagebox.h>
#include "customerselect.h"

void CustVehcEdit::initialize()
{
   custVehcTable->refresh();
   custVehcTable->selectRow(0);
   if ( custVehcTable->currentRecord() != NULL ) 
   {
      vehcForm->refresh(custVehcTable->currentRecord());
   }
}

void CustVehcEdit::accept()
{
   vehcForm->updateRecord();
   vehcForm->commitTransaction();
   done(QDialog::Accepted);
}

void CustVehcEdit::reject()
{
   if ( vehcForm->isInTransaction())
   {
      if (QMessageBox::warning(this, "Discarding Changes", 
                                "Canceling this will discard <b>ALL</b> of your changes. Are you sure you want to continue?",
                                QMessageBox::Yes, QMessageBox::No) == QMessageBox::Yes)
      {
         vehcForm->rollbackTransaction();
         done(QDialog::Rejected);
      }
   }
   else 
   {
      done(QDialog::Rejected);
   }
}


void CustVehcEdit::keyPressEvent( QKeyEvent * e )
{
   printf("CustVehcEdit::keyPressEvent(): Entry, have key press for %s\n", e->text().isNull() == true ? "NULL" : (const char*)e->text());
   if ( e->key() == Qt::Key_Escape ) 
   {
      e->accept();
      done(QDialog::Rejected);
   }
   printf("CustVehcEdit::keyPressEvent(): Exit\n");
}


void CustVehcEdit::transferVehc()
{
   int customer;

   CustomerSelect *cs = new CustomerSelect(this);
   if ( (customer = cs->exec()) > 0 ) 
   {
      QString cust_str;
      cust_str.setNum(customer);
      QString sql = "update vehicles set owner = '" + cust_str + "' where ident = '" + vehcForm->getLastIdent() + "'";
      printf("CustVehcEdit::transferVehc(): sql = |%s|\n", (const char*)sql);
      QSqlQuery q;
      q.prepare(sql);
      if ( ! q.exec() ) 
      {
         QMessageBox::warning(NULL, "Error!", "Error transfering vehicle: \n" + q.lastError().driverText() + q.lastError().databaseText(), "Okay");
         return;
      }
      custVehcTable->refresh();
   }
}
