/*********************************************************************************
**
**   $Id: previewworkorder.ui.h,v 1.8 2004/06/28 11:58:28 croftj Exp $
**   Copyright (c) 2004 Joe Croft <joe@croftj.net>
**   
**   This file is part of ah2.
**
**   ah2 is free software; you can redistribute it and/or modify
**   it under the terms of the GNU General Public License as published by
**   the Free Software Foundation; either version 2 of the License, or
**   (at your option) any later version.
**
**   Foobar is distributed in the hope that it will be useful,
**   but WITHOUT ANY WARRANTY; without even the implied warranty of
**   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**   GNU General Public License for more details.
**
**   You should have received a copy of the GNU General Public License
**   along with Foobar; if not, write to the Free Software
**   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
**
*********************************************************************************/

#include <qstring.h>
#include <qsqlquery.h>
#include <qmime.h>
#include <qpaintdevicemetrics.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qregexp.h>
#include <qsettings.h>
#include <qsimplerichtext.h>
#include "confdefs.h"
#include "Data/DataForm.h"

extern QSettings Config;


#define  INVOICE_HEADER1 "\
<qt bgcolor=\"#f0f0ff\">\
   <center>\
      <table width=100% cellpadding=10 bgcolor=\"#e0e0ff\"><tr bgcolor=\"#e0e0ff\"><td align=\"left\">\
         <img src=\"autohouse\" width=\"300\" hieght=\"84\">\
      </td><td align=\"right\"><font size=4><b>" + \
         bizaddr1 + "<br>\n" + \
         bizaddr2 + \
         bizcity + ", " + bizstate + ", " + bizzip + "<br>\n" + \
         bizphone + "<br>\n" + \
         bizfax + "<br>\n\
      </b></font></td></tr></table>\
      <hr width=66%>\
   </center>\
   <table width=\"100%\"><tr>\
   <td><font size=4>Invoice: <b>" + workorder + "</b></font></td>\
   <td align=\"right\"><font size=\"4\">Date: <b>" + date_out + "</b></font></td>\
   </tr></table><br>"

#define  INVOICE_HEADER2 "\
<qt bgcolor=\"#f0f0ff\">\
   <center>\
      <table width=100% cellpadding=10 bgcolor=\"#e0e0ff\"><tr><td align=\"center\">\
      <font size=6><b>" + bizname + "</b></font><br>\
      <font size=3><b>" + bizaddr1 + "<br>\n" + \
      bizaddr2 + \
      bizcity + ", " + bizstate + ", " + bizzip + "<br>\n" + \
      bizphone + "<br>\n" +  bizfax + "<br>\
      </b></font></td></tr></table>\
      <hr width=66%>\
   </center>\
   <table width=\"100%\"><tr>\
   <td><font size=4>Invoice: <b>" + workorder + "</b></font></td>\
   <td align=\"right\"><font size=\"4\">Date: <b>" + date_out + "</b></font></td>\
   </tr></table><br>"

#define INVOICE_CUSTOMER "\
   <table bgcolor=\"#fff0f0\" cellpadding=0 cellspacing=0 width=100%>\
      <tr><td><table cellspacing=0 width=100%>\
         <tr><td colspan=2 bgcolor=\"#d0d0d0\"><font size=4>Customer:</font></td></tr>\
         <tr><td>" + name + "<br>\
         " + addr + "<br>\
         " + city + ", " + state + ", " + zip + "<br>\
         Home #: " +  home_pn + "<br>\
         Work #: " + work_pn + "</td></tr>\
      </table></td><td><table cellspacing=0 height=100% width=100%>\
         <tr><td bgcolor=\"#d0d0d0\"><font size=4>Vehicle:</font></td></tr>\
         <tr><td>Make: " + make + ", Model: " + model + "<br>\
         Year: " + model_yr + "<br>\
         Color: " + color + "<br>\
         VIN: " + vin + "<br>\
         Odom: " + od_out + "</br></td></tr>\
      </table></td></tr>\
   </table>"

#define INVOICE_PARTS_HEADER "\
   <table bgcolor=\"#f0fff0\" cellpadding=0 cellspacing=0 width=100%>\
      <tr><td><table cellspacing=5 width=100%>\
         <tr bgcolor=\"#d0d0d0\">\
            <th width=50%><font size=4>Parts:</font></th>\
            <th width=15% align=\"right\"><font size=4>Qty</font></th>\
            <th width=35% align=\"right\"><font size=4>Cost</font></th>\
         </tr>"

#define INVOICE_PARTS_BODY "\
            <tr><td>" + descr + "</td><td align=\"right\">" + qty + "</td><td align=\"right\">" + cost + "</td></tr>"

#define  INVOICE_LABOR_HEADER "\
      </table></td><td>\
      <table cellspacing=5 height=100% width=100%>\
         <tr bgcolor=\"#d0d0d0\">\
            <th width=65%><font size=4>Labor:</font></th>\
            <th width=35% align=\"right\"><font size=4>Cost</font></th>\
         </tr>"

#define INVOICE_LABOR_BODY "\
         <tr><td>" + descr + "</td><td align=\"right\">" + cost + "</td></tr>"

#define INVOICE_BODY_TAIL "\
      </table><p>\
   </table><p>\
</qt>"

#define INVOICE_FOOTER "\
<qt bgcolor=\"#f0f0ff\">\
   <table bgcolor=\"#e0e0ff\" width=100%>\
      <tr>\
         <td width=70%><font size=4><b>Recomended Services</b></font><br>" + recomend + "</td>\
         <td bgcolor=\"#f0fff0\" width=30%>\
            <table width=100%>\
               <tr><td align=\"right\">Parts Total:</td><td align=\"right\">" + parts + "</td></tr>\
               <tr><td align=\"right\">Labor Total:</td><td align=\"right\">" + labor + "</td></tr>\
               <tr><td align=\"right\">Haz. Mat.:</td><td align=\"right\">" + hazmat + "</td></tr>\
               <tr><td align=\"right\">Sales Tax:</td><td align=\"right\">" + tax + "</td></tr>\
               <tr><td align=\"right\"><b>Total:</b></td><td align=\"right\"><b>" + total + "</b></td></tr>\
            </table>\
         </td>\
      </tr>\
   </table>\
</qt>\
<qt bgcolor=\"#f0f0ff\">\
   <table cellpadding=10 cellspacing=5 width=100%>\
      <tr><td colspan=2 align=\"center\">\
            <font size=1><b>NOTICE PURSUANT TO SECTION 70,001 TEXAS PROPERTY CODE</b></font>\
      </td></tr>\
      <tr>\
         <td><font size=1>\
            I hereby authorize the above repair work to be done with necassary materials\
            and hereby grant you and your employees permission to operate the vehicle for\
            the purposes of testing and inspection. An express mechanics lien hereby\
            acnowledged on the vehicle to secure the amount of repairs thereto. I further\
            acknowledge that you will not be held responsible for any loss or damage to\
            the vehicle or articles left in it due to causes beyond our control.</font>\
         </td>\
         <td><font size=1>\
            I am the person or agent acting on behalf of the person who is obligated to pay\
            for the repair of the motor vehicle subject to the repair order to which this\
            is attached. I understand that this vehicle is subject to repossesionin\
            accordance with Section 9,503, Texas Business and Commerce Code, if a written\
            order for payment for repairs of the vehicle is stopped, dishonored because of\
            insufficient funds, no funds, or because the drawer or or maker of the order\
            has no account or the account on which it is drawn has been closed.</font>\
         </td>\
      </tr>\
      <tr>\
      </tr>\
      <tr>\
         <td align=\"center\">\
            <hr width=%33%>\
            Signed\
         </td>\
         <td align=\"center\">\
            <hr width=%33%>\
            Person Responsible or Agent<br>\
         </td>\
      </tr>\
      <tr>\
         <td align=\"center\">\
         </td>\
         <td align=\"center\">\
            Date: ________________        Time: _________________<br>\
         </td>\
      </tr>\
   </table>\
</qt>"

void PreviewWorkOrder::setWorkorder( QString workOrder)
{
   QString closed, date_in, date_out, od_in, od_out, r_labor, r_tax, hazmat;
   QString labor, parts, tax, total, customer, vehicle, recomend, workorder;
   QString name, addr, city, state, zip, contact, home_pn, work_pn;
   QString make, model, model_yr, color, tag, vin, engine, trans, odom;
   QString bizname, bizicon, bizaddr1, bizaddr2, bizcity, bizstate, bizzip, bizphone, bizfax;

   /***********************************************/
   /*   Load  the  business information from the  */
   /*   settings                                  */
   /***********************************************/
   bizname  = Config.readEntry(CONFIG_BIZNAME,  "");
   bizicon  = Config.readEntry(CONFIG_BIZICON,  "");
   bizaddr1 = Config.readEntry(CONFIG_BIZADDR1, "");
   bizaddr2 = Config.readEntry(CONFIG_BIZADDR2, "");
   bizcity  = Config.readEntry(CONFIG_BIZCITY,  "");
   bizstate = Config.readEntry(CONFIG_BIZSTATE, "");
   bizzip   = Config.readEntry(CONFIG_BIZZIP,   "");
   bizphone = Config.readEntry(CONFIG_BIZPHONE, "");
   bizfax   = Config.readEntry(CONFIG_BIZFAX,   "");

   previewArea->setTextFormat(Qt::RichText);
   QString sql = QString("select closed, date_in, date_out, od_in, od_out, r_labor, r_tax, ") +
                 QString ("hazmat, labor, parts, tax, total, customer, vehicle, recomend, ident from workorders where ident = '") +
                 workOrder + "'";
   printf("sql = |%s|\n", (const char*)sql);
   QSqlQuery q1(sql);
   if ( q1.next() )
   {
      QDate din, dout;

      closed      = q1.value(0).toString();
      din         = q1.value(1).toDate();
      dout        = q1.value(2).toDate();
      od_in       = q1.value(3).toString();
      od_out      = q1.value(4).toString();
      r_labor     = q1.value(5).toString();
      r_tax       = q1.value(6).toString();
      hazmat      = MoneyEdit::formatCurrency(q1.value(7).toDouble());
      labor       = MoneyEdit::formatCurrency(q1.value(8).toDouble());
      parts       = MoneyEdit::formatCurrency(q1.value(9).toDouble());
      tax         = MoneyEdit::formatCurrency(q1.value(10).toDouble());
      total       = MoneyEdit::formatCurrency(q1.value(11).toDouble());
      customer    = q1.value(12).toString();
      vehicle     = q1.value(13).toString();
      recomend    = q1.value(14).toString();
      workorder   = q1.value(15).toString();

      QRegExp re1("");
      recomend.replace('\n', "<br>");
      recomend.replace('\r', "<br>");
      date_in = din.toString();
      date_out = dout.toString();
   }
   else
   {

   }
   sql = "select name, addr, city, state, zip, contact, home_pn, work_pn from customers where ident = '" + customer + "'";
   printf("sql = |%s|\n", (const char*)sql);
   QSqlQuery q2(sql);
   if ( q2.next() )
   {
      name     = q2.value(0).toString();
      addr     = q2.value(1).toString();
      city     = q2.value(2).toString();
      state    = q2.value(3).toString();
      zip      = q2.value(4).toString();
      contact  = q2.value(5).toString();
      home_pn  = q2.value(6).toString();
      work_pn  = q2.value(7).toString();
   }
   else
   {

   }
   sql = "select make, model, model_yr, color, tag, vin, engine, trans, odom from vehicles where ident = '" + vehicle + "'";
   printf("sql = |%s|\n", (const char*)sql);
   QSqlQuery q3(sql);
   if ( q3.next() )
   {
      make     = q3.value(0).toString();
      model    = q3.value(1).toString();
      model_yr = q3.value(2).toString();
      color    = q3.value(3).toString();
      tag      = q3.value(4).toString();
      vin      = q3.value(5).toString();
      engine   = q3.value(6).toString();
      trans    = q3.value(7).toString();
      odom     = q3.value(8).toString();
   }
   else
   {

   }
   

   /***********************************************/
   /*   If they have an Icon, use it! Otherwize,  */
   /*   use  plan  B  and just give the business  */
   /*   name and info.                            */
   /***********************************************/
   if ( bizicon != "" ) 
   {
      QMimeSourceFactory::defaultFactory()->setImage( "autohouse", QImage(bizicon));
      prtBody = INVOICE_HEADER1;
   }
   else 
   {
      prtBody = INVOICE_HEADER2;
   }

   prtBody += INVOICE_CUSTOMER;
   prtBody += INVOICE_PARTS_HEADER;
   sql = "select descr, qty, total as cost from wo_parts_v where workorder = '" + workOrder + "' order by ident";
   printf("sql = |%s|\n", (const char*)sql);
   QSqlQuery q4(sql);
   while (q4.next())
   {
      QString descr, qty, cost;
      descr    = q4.value(0).toString();
      qty      = q4.value(1).toString();
      cost     = MoneyEdit::formatCurrency(q4.value(2).toDouble());
      prtBody += INVOICE_PARTS_BODY;
   }

   prtBody += INVOICE_LABOR_HEADER;
   sql = "select descr, cost from wo_labor_v where workorder = '" + workOrder + "' order by ident";
   printf("sql = |%s|\n", (const char*)sql);
   QSqlQuery q5(sql);
   while (q5.next())
   {
      QString descr, cost;
      descr    = q5.value(0).toString();
      cost     = MoneyEdit::formatCurrency(q5.value(1).toDouble());
      prtBody += INVOICE_LABOR_BODY;
   }
   prtBody += INVOICE_BODY_TAIL;

   prtTrailer += INVOICE_FOOTER;
//   previewArea->append(prtHeader);
   previewArea->append(prtBody);
   previewArea->append(prtTrailer);
   previewArea->moveCursor(QTextEdit::MoveHome, false);
   previewArea->setReadOnly(true);
   fflush(stdout);
}

void PreviewWorkOrder::printWorkOrder()
{
   QPrinter prt(QPrinter::HighResolution);
   prt.setFullPage(TRUE);
   prt.setColorMode(QPrinter::Color);
   prt.setPageSize(QPrinter::Letter);
   if ( prt.setup(this) )
   {
      QPainter p(&prt);
      if ( !p.device() ) return;
      QPaintDeviceMetrics metrics(p.device());
      int dpiy = metrics.logicalDpiY();
      int margin = (int)((0.75/2.54) * dpiy);
      QRect body (margin, margin, metrics.width() - 2 * margin, metrics.height() - 2 * margin);
      QFont font(previewArea->QWidget::font());
      font.setPointSize(8);
      QSimpleRichText rt(previewArea->text(), font,
                         previewArea->context(),
                         previewArea->styleSheet(),
                         previewArea->mimeSourceFactory(),
                         body.height());
      rt.setWidth(&p, body.width());
      QRect view(body);
      int page = 1;
      do
      {
         rt.draw(&p, body.left(), body.top(), view, colorGroup());
         view.moveBy(0, body.height());
         p.translate(0, -body.height());
         p.setFont(font);
         if ( view.top() >= rt.height() )
            break;
         prt.newPage();
         page++;
      } while(TRUE);
   }
}
